﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace TreeViewTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var selected = this.treeViewDepartments.SelectedContainer;
            if (selected != null)
            {
                if (selected.Item is Organization)
                {
                    Department dept = new Department("New Dept");
                    (selected.Item as Organization).Departments.Add(dept);
                    this.treeViewDepartments.IsLoadOnDemandEnabled = false;
                    this.treeViewDepartments.ExpandItemByPath(dept.GetFullPath(), "|");
                    this.treeViewDepartments.ContainerFromItemRecursive(dept).IsSelected = true;
                    this.treeViewDepartments.IsLoadOnDemandEnabled = true;
                }
                else if (selected.Item is Department)
                {
                    Department dept = new Department("New Sub Dept");
                    (selected.Item as Department).SubDepartments.Add(dept);
                    this.treeViewDepartments.IsLoadOnDemandEnabled = false;
                    this.treeViewDepartments.ExpandItemByPath(dept.GetFullPath(), "|");
                    this.treeViewDepartments.ContainerFromItemRecursive(dept).IsSelected = true;
                    this.treeViewDepartments.IsLoadOnDemandEnabled = true;
                }
            }
        }

        private void treeViewDepartments_LoadOnDemand(object sender, Telerik.Windows.RadRoutedEventArgs e)
        {
            var detp = e.OriginalSource as RadTreeViewItem;
            if (detp != null)
            {
                Department alpha = new Department("Sub Dept 1");
                Department beta = new Department("Sub Dept 2");

                (detp.Item as Department).SubDepartments.Add(alpha);
                (detp.Item as Department).SubDepartments.Add(beta);

            }
            detp.IsLoadingOnDemand = false;
        }

        private void treeViewDepartments_ItemPrepared(object sender, Telerik.Windows.Controls.RadTreeViewItemPreparedEventArgs e)
        {
          
        }
    }
}
